;Autor: jpd, ts-soft
;http://www.purebasic.fr/german/viewtopic.php?p=311263#p311263

EnableExplicit

Define EventID

Structure WTS_SESSION_INFO Align #PB_Structure_AlignC
  SessionId.l
  pWinStationName.s
  State.l;.WTS_CONNECTSTATE_CLASS
EndStructure

Structure WTS_SESSION_INFO_1 Align #PB_Structure_AlignC
  ExecEnvId.l
  State.l
  SessionId.l
  pSessionName.s
  pHostName.s
  pUserName.s
  pDomainName.s
  pFarmName.s
EndStructure

Enumeration ;WTS_CONNECTSTATE_CLASS
  #WTSActive
  #WTSConnected;
  #WTSConnectQuery;
  #WTSShadow;
  #WTSDisconnected;
  #WTSIdle;
  #WTSListen;
  #WTSReset;
  #WTSDown;
  #WTSInit;
EndEnumeration

Enumeration ;WTS_TYPE_CLASS
  #WTSTypeProcessInfoLevel0
  #WTSTypeProcessInfoLevel1
  #WTSTypeSessionInfoLevel1
EndEnumeration

Prototype  WTSEnumerateSessionsEx(hServer, *pLevel, Filter, *ppSessionInfo.WTS_SESSION_INFO_1, *pCount)
Prototype  WTSEnumerateSessions(hServer, Reserved, Version, *ppSessionInfo.WTS_SESSION_INFO, *pCount)
Prototype  WTSFreeMemoryEx(WTSTypeClass, pMemory, NumberOfEntries);.WTS_TYPE_CLASS
Prototype  WTSFreeMemory(pMemory)
Prototype  WTSOpenServer(pServerName)
Prototype  WTSCloseServer(hServer)

Global WTSEnumerateSessionsEx.WTSEnumerateSessionsEx
Global WTSEnumerateSessions.WTSEnumerateSessions
Global WTSFreeMemoryEx.WTSFreeMemoryEx
Global WTSFreeMemory.WTSFreeMemory
Global WTSOpenServer.WTSOpenServer
Global WTSCloseServer.WTSCloseServer

Global NewList ppSessionInfoEx.WTS_SESSION_INFO_1()
Global NewList ppSessionInfo.WTS_SESSION_INFO()

Macro lpComputerName(Computername)
  Protected lpComputername,lpNullComputername
  
  If ComputerName = "."
    lpNullComputername = 0
    lpComputername=@lpNullComputername
  Else
    lpComputername=@Computername
  EndIf
  
EndMacro

Procedure.i wtsapi32_LoadDLL()
  Protected.i hDLL
 
  hDLL = OpenLibrary(#PB_Any, "wtsapi32.dll")
  If hDLL <> 0
    
    WTSCloseServer = GetFunction(hDLL, "WTSCloseServer")
    WTSFreeMemory = GetFunction(hDLL, "WTSFreeMemory")
    
    CompilerIf #PB_Compiler_Unicode
      WTSEnumerateSessionsEx = GetFunction(hDLL, "WTSEnumerateSessionsExW")
      WTSEnumerateSessions = GetFunction(hDLL, "WTSEnumerateSessionsW")
      WTSFreeMemoryEx = GetFunction(hDLL, "WTSFreeMemoryExW")
      WTSOpenServer = GetFunction(hDLL, "WTSOpenServerW")
    CompilerElse
      WTSEnumerateSessionsEx = GetFunction(hDLL, "WTSEnumerateSessionsExA")
      WTSEnumerateSessions = GetFunction(hDLL, "WTSEnumerateSessionsA")
      WTSFreeMemoryEx = GetFunction(hDLL, "WTSFreeMemoryExA")
      WTSOpenServer = GetFunction(hDLL, "WTSOpenServerA")
    CompilerEndIf
    
    ProcedureReturn hDLL
  EndIf
 
  ProcedureReturn #False
EndProcedure

Procedure GetWTSSessions(List ppSessionInfo.WTS_SESSION_INFO_1(), ComputerName.s = ".")
  Protected WTSHandle.i
  Protected pLevel=1
  Protected Filter=0
  Protected *SessionInfo
  Protected pCount
  Protected Ret, i
  
  lpComputerName(Computername)
  
  WTSHandle=WTSOpenServer(lpComputerName)
  If WTSHandle
    Ret=WTSEnumerateSessionsEx(WTSHandle, @pLevel, Filter,@*SessionInfo,@pCount)
    
    If Ret <> 0
      For i = 0 To pCount - 1
        AddElement(ppSessionInfo())
        CopyMemory (*SessionInfo+SizeOf(WTS_SESSION_INFO_1)*i, ppSessionInfo(),SizeOf(WTS_SESSION_INFO_1)*SizeOf(Character))
      Next
      WTSFreeMemoryEx(#WTSTypeSessionInfoLevel1, *SessionInfo, pCount-1)
    EndIf
    
    WTSCloseServer(WTSHandle)
  EndIf
  
EndProcedure

Procedure.s WTS_CONNECTSTATE_CLASS(ValState.l)
  Select ValState
    Case  #WTSActive
      ProcedureReturn "A user is logged on To the WinStation."
    Case #WTSConnected
      ProcedureReturn "The WinStation is connected To the client."
    Case #WTSConnectQuery
      ProcedureReturn "The WinStation is in the process of connecting To the client."
    Case #WTSShadow
      ProcedureReturn "The WinStation is shadowing another WinStation."
    Case #WTSDisconnected
      ProcedureReturn "The WinStation is active but the client is disconnected."
    Case #WTSIdle
      ProcedureReturn "The WinStation is waiting For a client To connect."
    Case #WTSListen
      ProcedureReturn "The WinStation is listening For a connection. A listener session waits For requests For new client connections. No user is logged on a listener session. A listener session cannot be reset, shadowed, Or changed To a regular client session."
    Case #WTSReset
      ProcedureReturn "The WinStation is being reset."
    Case #WTSDown
      ProcedureReturn "The WinStation is down due To an error."
    Case #WTSInit
      ProcedureReturn "The WinStation is initializing."
     
  EndSelect
 
EndProcedure

Procedure IsUserLoggedOn(List ppSessionInfo.WTS_SESSION_INFO(), ComputerName.s = ".")
  Protected WTSHandle.i
  Protected Version=1
  Protected Filter=0
  Protected *SessionInfo
  Protected pCount
  Protected Ret, i
 
  If OSVersion() > #PB_OS_Windows_Vista
    lpComputerName(Computername)
    WTSHandle=WTSOpenServer(lpComputerName)
  Else
    WTSHandle=WTSOpenServer(0)
  EndIf

  If WTSHandle
    Ret=WTSEnumerateSessions(WTSHandle, #Null, Version,@*SessionInfo,@pCount)
    
    If Ret <> 0
      For i = 0 To pCount - 1
        AddElement(ppSessionInfo())
        CopyMemory (*SessionInfo+SizeOf(WTS_SESSION_INFO)*i, ppSessionInfo(),SizeOf(WTS_SESSION_INFO)*SizeOf(Character))
      Next
      WTSFreeMemory(*SessionInfo)
    EndIf
   
    WTSCloseServer(WTSHandle)
  EndIf
  
EndProcedure

Procedure GetAllUsers(Gadget)
  Protected.i hDLL
  
  hDLL=wtsapi32_LoadDLL()
  
  If hDLL=0
    End
  EndIf
  
  If OSVersion() > #PB_OS_Windows_Vista
    GetWTSSessions(ppSessionInfoEx.WTS_SESSION_INFO_1())
  EndIf
  IsUserLoggedOn(ppSessionInfo.WTS_SESSION_INFO())
  CloseLibrary(hDll)

  AddGadgetItem(Gadget, -1, "---WTSEnumerateSessionsEx---", 0, 0)
  
  ForEach ppSessionInfoEx()
    If ppSessionInfoEx()\State = #WTSActive
      AddGadgetItem(Gadget, -1, "Session ID: "+ ppSessionInfoEx()\SessionId, 0, 0)
      AddGadgetItem(Gadget, -1, "Session Name: "+ppSessionInfoEx()\pSessionName, 0, 0)
      AddGadgetItem(Gadget, -1, "UserName: "+ ppSessionInfoEx()\pUserName, 0, 0)
      AddGadgetItem(Gadget, -1, "Connect Status: "+ WTS_CONNECTSTATE_CLASS(ppSessionInfoEx()\State), 0, 0)
    EndIf
    
  Next
  
  AddGadgetItem(Gadget, -1, "---WTSEnumerateSessions---", 0, 0)
  
  ForEach ppSessionInfo()
    If ppSessionInfo()\State = #WTSActive
      AddGadgetItem(Gadget, -1, "WinStationName: "+ ppSessionInfo()\pWinStationName, 0, 0)
      AddGadgetItem(Gadget, -1, "Session ID: "+ppSessionInfo()\SessionId, 0, 0)
      AddGadgetItem(Gadget, -1, "Connect Status: "+ WTS_CONNECTSTATE_CLASS(ppSessionInfo()\State), 0, 0)
    EndIf
  Next
  
EndProcedure

If OpenWindow(0, 0, 0, 500, 400, "Window", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
  ListViewGadget(1, 0, 0, WindowWidth(0), WindowHeight(0), 0)
  
  GetAllUsers(1)
  
  Repeat
    EventID = WaitWindowEvent()
    If EventID = #PB_Event_CloseWindow
      End
    EndIf
  ForEver
EndIf
; IDE Options = PureBasic 5.31 (Windows - x64)
; Folding = --
; EnableUnicode
; EnableXP
; EnableUser
; EnableCompileCount = 0
; EnableBuildCount = 0