EnableExplicit

Define a
Global SelectedItemColor = CreateSolidBrush_(GetSysColor_(#COLOR_HIGHLIGHT))
Global StandardItemColor = GetStockObject_(#WHITE_BRUSH)

Enumeration
  #ListIcon
EndEnumeration

Procedure GetTextWidth(Text$)
  Protected hDC
  Protected Size.Size
  
  hDC = GetDC_(WindowID(0))
  SelectObject_(hDC, GetStockObject_(#DEFAULT_GUI_FONT))
  GetTextExtentPoint32_(hDC, Text$, Len(Text$), Size)
  ReleaseDC_(0, hDC)
  
  ProcedureReturn Size\cx
EndProcedure

Procedure WindowCallback(hWnd, uMsg, wParam, lParam) 
  Protected a
  Protected CurrentItem
  Protected CurrentColumn
  Protected CurrentItemText$
  Protected NewItemText$
  Protected CurrentColumnWidth
  Protected *NMLVCUSTOMDRAW.NMLVCUSTOMDRAW
  Protected RECT.RECT
  
  Select uMsg
    Case #WM_NOTIFY
      *NMLVCUSTOMDRAW = lParam
      If *NMLVCUSTOMDRAW\nmcd\hdr\hwndFrom = GadgetID(#ListIcon)
        If *NMLVCUSTOMDRAW\nmcd\hdr\code = #NM_CUSTOMDRAW
          Select *NMLVCUSTOMDRAW\nmcd\dwDrawStage
            Case #CDDS_PREPAINT
              ProcedureReturn #CDRF_NOTIFYITEMDRAW
            Case #CDDS_ITEMPREPAINT
              ProcedureReturn #CDRF_NOTIFYSUBITEMDRAW;
            Case #CDDS_ITEMPREPAINT | #CDDS_SUBITEM
              CurrentItem = *NMLVCUSTOMDRAW\nmcd\dwItemSpec
              CurrentColumn = *NMLVCUSTOMDRAW\iSubItem
              
              RECT\left = #LVIR_LABEL
              RECT\top = *NMLVCUSTOMDRAW\iSubItem
              
              SendMessage_(GadgetID(#ListIcon), #LVM_GETSUBITEMRECT, CurrentItem, RECT)
              
              CurrentItemText$ = GetGadgetItemText(#ListIcon, CurrentItem, CurrentColumn)
              CurrentColumnWidth = SendMessage_(GadgetID(#ListIcon), #LVM_GETCOLUMNWIDTH, CurrentColumn, 0)
              
              For a=1 To Len(CurrentItemText$)
                NewItemText$ = Mid(CurrentItemText$, a)
                If (GetTextWidth(NewItemText$)+GetTextWidth("...")+12) < CurrentColumnWidth
                  Break
                EndIf
              Next
              If CurrentItemText$ <> NewItemText$
                NewItemText$ = "..." + NewItemText$
              EndIf
              
              If GetGadgetState(#ListIcon) = CurrentItem
                FillRect_(*NMLVCUSTOMDRAW\nmcd\hdc, RECT, SelectedItemColor)
                SetTextColor_(*NMLVCUSTOMDRAW\nmcd\hdc, #White)
              Else
                FillRect_(*NMLVCUSTOMDRAW\nmcd\hdc, RECT, StandardItemColor)
                SetTextColor_(*NMLVCUSTOMDRAW\nmcd\hdc, #Black)
              EndIf
              
              InflateRect_(RECT, -2, 0)
              
              DrawText_(*NMLVCUSTOMDRAW\nmcd\hdc, NewItemText$, Len(NewItemText$), RECT, #DT_END_ELLIPSIS)
              
          EndSelect
          
          ProcedureReturn #CDRF_SKIPDEFAULT
        EndIf
      EndIf
  EndSelect
  
  ProcedureReturn #PB_ProcessPureBasicEvents 
EndProcedure

If OpenWindow(0, 0, 0, 500, 400, "Window", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
  ListIconGadget(#ListIcon, 0, 0, WindowWidth(0), WindowHeight(0), "Column", 200, 0)
  
  SendMessage_(GadgetID(#ListIcon), #WM_SETREDRAW, 0, 0)
  For a = 1 To 1000
    AddGadgetItem(#ListIcon, -1, "C:\Windows\System32\drivers\etc\lmhosts" + Str(a*10) + ".sam")
  Next
  SendMessage_(GadgetID(#ListIcon), #WM_SETREDRAW, 1, 0)
  
  SetWindowCallback(@WindowCallback(), 0)
  
  Repeat
    Select WaitWindowEvent()
      Case #PB_Event_CloseWindow
        DeleteObject_(SelectedItemColor)
        DeleteObject_(StandardItemColor)
        End
    EndSelect
  ForEver
EndIf