EnableExplicit

Define a
Define uFormat
Define ClipboardFormatTotal
Define lpszFormatName$

OpenClipboard_(0)

ClipboardFormatTotal = CountClipboardFormats_()

For a=0 To ClipboardFormatTotal-1
  uFormat = EnumClipboardFormats_(a)
  
  Select uFormat
    Case #CF_BITMAP
      Debug "A handle to a bitmap (HBITMAP)."
    Case #CF_DIB
      Debug "A memory object containing a BITMAPINFO structure followed by the bitmap bits."
    Case #CF_DIBV5
      Debug "	A memory object containing a BITMAPV5HEADER structure followed by the bitmap color space information and the bitmap bits."
    Case #CF_DIF
      Debug "Software Arts' Data Interchange Format."
    Case #CF_DSPBITMAP
      Debug "Bitmap display format associated with a private format. The hMem parameter must be a handle to data that can be displayed in bitmap format in lieu of the privately formatted data."
    Case #CF_DSPENHMETAFILE
      Debug "Enhanced metafile display format associated with a private format. The hMem parameter must be a handle to data that can be displayed in enhanced metafile format in lieu of the privately formatted data."
    Case #CF_DSPMETAFILEPICT
      Debug "Metafile-picture display format associated with a private format. The hMem parameter must be a handle to data that can be displayed in metafile-picture format in lieu of the privately formatted data."
    Case #CF_DSPTEXT
      Debug "Text display format associated with a private format. The hMem parameter must be a handle to data that can be displayed in text format in lieu of the privately formatted data."
    Case #CF_ENHMETAFILE
      Debug "A handle to an enhanced metafile (HENHMETAFILE)."
    Case #CF_GDIOBJFIRST
      Debug "Start of a range of integer values for application-defined GDI object clipboard formats. The end of the range is CF_GDIOBJLAST. Handles associated with clipboard formats in this range are not automatically deleted using the GlobalFree function when the clipboard is emptied. Also, when using values in this range, the hMem parameter is not a handle to a GDI object, but is a handle allocated by the GlobalAlloc function with the GMEM_MOVEABLE flag."
    Case #CF_GDIOBJLAST
      Debug "See CF_GDIOBJFIRST."
    Case #CF_HDROP
      Debug "A handle to type HDROP that identifies a list of files. An application can retrieve information about the files by passing the handle to the DragQueryFile function."
    Case #CF_LOCALE
      Debug "The data is a handle to the locale identifier associated with text in the clipboard. When you close the clipboard, if it contains CF_TEXT data but no CF_LOCALE data, the system automatically sets the CF_LOCALE format to the current input language. You can use the CF_LOCALE format to associate a different locale with the clipboard text. An application that pastes text from the clipboard can retrieve this format to determine which character set was used to generate the text. Note that the clipboard does not support plain text in multiple character sets. To achieve this, use a formatted text data type such as RTF instead.  The system uses the code page associated with CF_LOCALE to implicitly convert from CF_TEXT to CF_UNICODETEXT. Therefore, the correct code page table is used for the conversion."
    Case #CF_METAFILEPICT
      Debug "Handle to a metafile picture format as defined by the METAFILEPICT structure. When passing a CF_METAFILEPICT handle by means of DDE, the application responsible for deleting hMem should also free the metafile referred to by the CF_METAFILEPICT handle."
    Case #CF_OEMTEXT
      Debug "Text format containing characters in the OEM character set. Each line ends with a carriage return/linefeed (CR-LF) combination. A null character signals the end of the data."
    Case #CF_OWNERDISPLAY
      Debug "Owner-display format. The clipboard owner must display and update the clipboard viewer window, and receive the WM_ASKCBFORMATNAME, WM_HSCROLLCLIPBOARD, WM_PAINTCLIPBOARD, WM_SIZECLIPBOARD, and WM_VSCROLLCLIPBOARD messages. The hMem parameter must be NULL."
    Case #CF_PALETTE
      Debug "Handle to a color palette. Whenever an application places data in the clipboard that depends on or assumes a color palette, it should place the palette on the clipboard as well. If the clipboard contains data in the CF_PALETTE (logical color palette) format, the application should use the SelectPalette and RealizePalette functions to realize (compare) any other data in the clipboard against that logical palette. When displaying clipboard data, the clipboard always uses as its current palette any object on the clipboard that is in the CF_PALETTE format."
    Case #CF_PENDATA
      Debug "Data for the pen extensions to the Microsoft Windows for Pen Computing."
    Case #CF_PRIVATEFIRST
      Debug "Start of a range of integer values for private clipboard formats. The range ends with CF_PRIVATELAST. Handles associated with private clipboard formats are not freed automatically; the clipboard owner must free such handles, typically in response to the WM_DESTROYCLIPBOARD message."
    Case #CF_PRIVATELAST
      Debug "See CF_PRIVATEFIRST."
    Case #CF_RIFF
      Debug "Represents audio data more complex than can be represented in a CF_WAVE standard wave format."
    Case #CF_SYLK
      Debug "Microsoft Symbolic Link (SYLK) format."
    Case #CF_TEXT
      Debug "Text format. Each line ends with a carriage return/linefeed (CR-LF) combination. A null character signals the end of the data. Use this format for ANSI text."
    Case #CF_TIFF
      Debug "Tagged-image file format."
    Case #CF_UNICODETEXT
      Debug "Unicode text format. Each line ends with a carriage return/linefeed (CR-LF) combination. A null character signals the end of the data."
    Case #CF_WAVE
      Debug "Represents audio data in one of the standard wave formats, such as 11 kHz or 22 kHz PCM."
    Default
      lpszFormatName$ = Space(1024)
      If GetClipboardFormatName_(uFormat, @lpszFormatName$, Len(lpszFormatName$))
        Debug lpszFormatName$
      EndIf
  EndSelect
Next

CloseClipboard_()